Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::Clarinet Class Reference

STK clarinet physical model class. More...

`#include <Clarinet.h>`

Inheritance diagram for stk::Clarinet:

List of all members.

## Public Member Functions
| Clarinet (StkFloat lowestFrequency=8.0)
| Class constructor, taking the lowest desired playing frequency.
| ~Clarinet (void)
| Class destructor.
void | clear (void)
| Reset and clear all internal state.
void | setFrequency (StkFloat frequency)
| Set instrument parameters for a particular frequency.
void | startBlowing (StkFloat amplitude, StkFloat rate)
| Apply breath pressure to instrument with given amplitude and rate of increase.
void | stopBlowing (StkFloat rate)
| Decrease breath pressure with given rate of decrease.
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude.
void | noteOff (StkFloat amplitude)
| Stop a note with the given amplitude (speed of decay).
void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.

## Detailed Description

STK clarinet physical model class.

This class implements a simple clarinet physical model, as discussed by Smith (1986), McIntyre, Schumacher, Woodhouse (1983), and others.

This is a digital waveguide model, making its use possibly subject to patents held by Stanford University, Yamaha, and others.

Control Change Numbers:

- Reed Stiffness = 2
- Noise Gain = 4
- Vibrato Frequency = 11
- Vibrato Gain = 1
- Breath Pressure = 128

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Constructor & Destructor Documentation

stk::Clarinet::Clarinet | ( | StkFloat | lowestFrequency = `8.0` | ) |

Class constructor, taking the lowest desired playing frequency.

An StkError will be thrown if the rawwave path is incorrectly set.

## Member Function Documentation

StkFrames & stk::Clarinet::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Instrmnt.

    00124 {
    00125   unsigned int nChannels = lastFrame_.channels();
    00126 #if defined(_STK_DEBUG_)
    00127   if ( channel > frames.channels() - nChannels ) {
    00128     oStream_ << "Clarinet::tick(): channel and StkFrames arguments are incompatible!";
    00129     handleError( StkError::FUNCTION_ARGUMENT );
    00130   }
    00131 #endif
    00132
    00133   StkFloat *samples = &frames[channel];
    00134   unsigned int j, hop = frames.channels() - nChannels;
    00135   if ( nChannels == 1 ) {
    00136     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
    00137       *samples++ = tick();
    00138   }
    00139   else {
    00140     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00141       *samples++ = tick();
    00142       for ( j=1; j<nChannels; j++ )
    00143         *samples++ = lastFrame_[j];
    00144     }
    00145   }
    00146
    00147   return frames;
    00148 }

The documentation for this class was generated from the following file:

- Clarinet.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.